library ac_dart.host_event_model;

import 'package:atlassian_connect_host/host_model.dart';
export 'package:atlassian_connect_host/host_model.dart';

class AcHostEventType {
  final int ordinal;
  const AcHostEventType(this.ordinal);

  static const AcHostEventType installed = const AcHostEventType(1);

  static AcHostEventType fromLiteral(String literal) {
    return literal == "installed" ? installed : null; // TODO: dodgy
  }
}

abstract class AcHostEvent {
  final AcHostEventType eventType;
  AcHostEvent(this.eventType);
}

class InstallationEvent extends AcHostEvent {
  final AcHostRegistration hostRegistration;

  InstallationEvent(AcHostEventType eventType, this.hostRegistration)
      : super(eventType);

  InstallationEvent.fromJson(Map<String, Object> jsonMap)
      : this(AcHostEventType.installed, (new MutableAcHostRegistration()
          ..sharedSecret = jsonMap['sharedSecret']
          ..hostDetails = (new MutableAcHostDetails()
              ..key = jsonMap['clientKey']
              ..baseUrl = Uri.parse(jsonMap['baseUrl'])
              ..productType = ProductType.fromLiteral(jsonMap['productType'])
              ..publicKey = jsonMap['publicKey'])).toImmutable());
}
